const express = require("express");
const router = express.Router();
const multer = require("multer");
const db_con = require("../connection");

const storage = multer.diskStorage({
  destination: function (req, file, cb) {
    cb(null, "uploads/");
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + file.originalname);
  },
});

let upload = multer({
  storage: storage,
});

router.get("/", (req, res, next) => {
  res.send("Hellow world");
  console.log("Tour Added");
});

router.post("/addTourBookings", (req, res) => {
  let bookingBody = req.body;
  let tableHeader = [];
  tableHeader.push(
    `agent_id`,
    `tour_agent_name`,
    `user_type`,
    `agent_color`,
    `booking_tour_id`,
    `booking_tour_title`,
    `booking_tour_banner_image`,
    `booking_tour_category`,
    `booking_tour_price`,
    `booking_total_price`,
    `booking_grand_total_price`,
    `booking_tax`,
    `booking_start_date`,
    `booking_end_date`,
    `booking_name`,
    `booking_email`,
    `booking_password`,
    `booking_phone`,
    `booking_people`,
    `booking_spcl_content`,
    `booking_trams`,
    `booking_id`,
    `booking_at`,
    `booking_hotel`,
    `booking_status`,
    `payment_status`,
    `booking_review`
  );
  // let tableHeader = req.body.tableHeader.join(',')
  let query = "INSERT INTO all_bookings (" + tableHeader + ") VALUES ?";
  let values = bookingBody.reduce((o, a) => {
    let ini = [];
    ini.push(a.agent_id);
    ini.push(a.tour_agent_name);
    ini.push(a.user_type);
    ini.push(a.agent_color);
    ini.push(a.booking_tour_id);
    ini.push(a.booking_tour_title);
    ini.push(a.booking_tour_banner_image);
    ini.push(a.booking_tour_category);
    ini.push(a.booking_tour_price);
    ini.push(a.booking_total_price);
    ini.push(a.booking_grand_total_price);
    ini.push(a.booking_tax);
    ini.push(a.booking_start_date);
    ini.push(a.booking_end_date);
    ini.push(a.booking_name);
    ini.push(a.booking_email);
    ini.push(a.booking_password);
    ini.push(a.booking_phone);
    ini.push(a.booking_people);
    ini.push(a.booking_spcl_content);
    ini.push(a.booking_trams);
    ini.push(a.booking_id);
    ini.push(a.booking_at);
    ini.push(a.booking_hotel);
    ini.push(a.booking_status);
    ini.push(a.payment_status);
    ini.push(a.booking_review);
    o.push(ini);
    return o;
  }, []);

  db_con.query(query, [values], (error, results, fields) => {
    if (error) {
      console.log(error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Booking Added Successfully");
      res.send({
        code: 200,
        message: "Booking Added Successfully",
      });
    }
  });
});

router.post("/editSingleBooking", (req, res) => {
  const bookingBody = req.body.bookingObject;
  let container = [];
  let tableHeader = [];
  container.push(bookingBody);

  let query = `DELETE FROM all_bookings WHERE booking_id = ?`;

  // console.log(bookingBody.tour_id)
  db_con.query(query, [bookingBody.booking_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      tableHeader.push(
        `agent_id`,
        `tour_agent_name`,
        `user_type`,
        `agent_color`,
        `booking_tour_id`,
        `booking_tour_title`,
        `booking_tour_banner_image`,
        `booking_tour_category`,
        `booking_tour_price`,
        `booking_total_price`,
        `booking_grand_total_price`,
        `booking_tax`,
        `booking_start_date`,
        `booking_end_date`,
        `booking_name`,
        `booking_email`,
        `booking_password`,
        `booking_phone`,
        `booking_people`,
        `booking_spcl_content`,
        `booking_trams`,
        `booking_id`,
        `booking_at`,
        "booking_hotel",
        `booking_status`,
        `payment_status`
      );
      // let tableHeader = req.body.tableHeader.join(',')
      let query = "INSERT INTO all_bookings (" + tableHeader + ") VALUES ?";
      let values = container.reduce((o, a) => {
        let ini = [];
        ini.push(a.agent_id);
        ini.push(a.tour_agent_name);
        ini.push(a.user_type);
        ini.push(a.agent_color);
        ini.push(a.booking_tour_id);
        ini.push(a.booking_tour_title);
        ini.push(a.booking_tour_banner_image);
        ini.push(a.booking_tour_category);
        ini.push(a.booking_tour_price);
        ini.push(a.booking_total_price);
        ini.push(a.booking_grand_total_price);
        ini.push(a.booking_tax);
        ini.push(a.booking_start_date);
        ini.push(a.booking_end_date);
        ini.push(a.booking_name);
        ini.push(a.booking_email);
        ini.push(a.booking_password);
        ini.push(a.booking_phone);
        ini.push(a.booking_people);
        ini.push(a.booking_spcl_content);
        ini.push(a.booking_trams);
        ini.push(a.booking_id);
        ini.push(a.booking_at);
        ini.push(a.booking_hotel);
        ini.push(a.booking_status);
        ini.push(a.payment_status);
        o.push(ini);
        return o;
      }, []);

      db_con.query(query, [values], (error, results, fields) => {
        if (error) {
          console.log(error);
          res.send({
            code: 400,
            failed: "error request",
          });
        } else {
          res.send({
            code: 200,
            message: "Tour Edited Successfully",
          });
        }
      });
    }
  });
});

//update booking

router.post("/updateBookingStatusDetails", (req, res) => {
  let query = `UPDATE all_bookings SET booking_status = ? WHERE booking_id = ?; `;
  console.log(req.body.booking_id);
  const bookingBody = req.body;
  db_con.query(
    query,
    [bookingBody.booking_status, bookingBody.booking_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

// review

router.post("/updateBookingTourReview", (req, res) => {
  let query = `UPDATE all_bookings SET booking_review = ? WHERE booking_id = ?; `;
  const reviewBody = req.body;
  db_con.query(
    query,
    [reviewBody.tour_review_data, reviewBody.booking_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

router.post("/updatePaymentStatusDetails", (req, res) => {
  let query = `UPDATE all_bookings SET payment_status = ? WHERE booking_id = ?; `;
  console.log(req.body.booking_id);
  const bookingBody = req.body;
  db_con.query(
    query,
    [bookingBody.payment_status, bookingBody.booking_id],
    (error, results, fields) => {
      if (error) {
        console.log("error ocurred", error);
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Updated Successfully",
        });
      }
    }
  );
});

const id = (length) => {
  let mask = "";
  mask += "0123456789";
  let result = "";
  for (var i = length; i > 0; --i)
    result += mask[Math.round(Math.random() * (mask.length - 1))];
  return result;
};

// get api

router.get("/getBookingsForVendor", (req, res) => {
  const vendortype = req.query.vendortype;
  const vendorId = req.query.vendorId;
  console.log(vendortype);
  if (vendortype == "Admin") {
    query = "SELECT * FROM all_bookings ORDER BY booking_at DESC";
    db_con.query(query, function (error, results, fields) {
      if (error) {
        res.send({
          code: 400,
          failed: "error request",
        });
      } else {
        res.send({
          code: 200,
          message: "Success",
          Payload: results,
        });
      }
    });
  } else {
    query =
      "SELECT * FROM all_bookings WHERE user_type=? AND agent_id=? ORDER BY booking_at DESC";
    db_con.query(
      query,
      [vendortype, vendorId],
      function (error, results, fields) {
        if (error) {
          console.log(error);
          res.send({
            code: 402,
            failed: "error request",
          });
        } else {
          if (results.length != 0) {
            res.send({
              code: 200,
              message: "Login Successful",
              Payload: results,
            });
          } else {
            res.send({
              code: 402,
              message: "No Data Found",
            });
          }
        }
      }
    );
  }
});

router.get("/getBookingsForUser", (req, res) => {
  const user_email = req.query.userEmail;
  query = "SELECT * FROM all_bookings WHERE booking_email=?";
  db_con.query(query, [user_email], function (error, results, fields) {
    if (error) {
      console.log(error);
      res.send({
        code: 402,
        failed: "error request",
      });
    } else {
      if (results.length != 0) {
        res.send({
          code: 200,
          message: "Login Successful",
          Payload: results,
        });
      } else {
        res.send({
          code: 402,
          message: "No Data Found",
        });
      }
    }
  });
});

router.get("/getAllbookings", (req, res) => {
  query = "SELECT * FROM all_bookings ORDER BY booking_at DESC";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

// delete api

router.post("/deleteBookings", (req, res) => {
  const body = req.body;
  let query = `DELETE FROM all_bookings WHERE booking_id = ?`;
  console.log(body);
  db_con.query(query, [body.booking_id], (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Resultats: ", results);
      res.send({
        code: 200,
        message: "Deleted Successfully",
      });
    }
  });
});

module.exports = router;
