const express = require("express");
const router = express.Router();
const multer = require("multer");
const db_con = require("../connection");

const storage = multer.diskStorage({
  destination: function (req, file, cb) {
    cb(null, "uploads/");
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + file.originalname);
  },
});

let upload = multer({
  storage: storage,
});

var mediaUpload = upload.fields([
  {
    name: "mediaImages",
    maxCount: 100,
  },
]);

router.get("/", (req, res, next) => {
  res.send("Image uploader");
  console.log("Tour Added");
});

router.post("/addImages", mediaUpload, (req, res) => {
  const body = req.body;
  let mediaImageData = [];
  let tableHeader = [];
  req.files["mediaImages"].forEach((element) => {
    let obj = {};
    obj = {
      img_id: id(8).toString(),
      img_name: element.filename,
      img_base_url: element.path,
      img_size: element.size,
      img_mimetype: element.mimetype,
      img_url: process.env.BASE_URI + element.path,
    };
    mediaImageData.push(obj);
  });

  tableHeader.push(
    `img_id`,
    `img_name`,
    `img_base_url`,
    `img_size`,
    `img_mimetype`,
    `img_url`
  );
  let query = "INSERT INTO images (" + tableHeader + ") VALUES ?";
  let values = mediaImageData.reduce((o, a) => {
    let ini = [];
    ini.push(a.img_id);
    ini.push(a.img_name);
    ini.push(a.img_base_url);
    ini.push(a.img_size);
    ini.push(a.img_mimetype);
    ini.push(a.img_url);
    o.push(ini);
    return o;
  }, []);
  db_con.query(query, [values], (error, results, fields) => {
    if (error) {
      console.log(error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Images Added Successfully",
      });
    }
  });
});

const id = (length) => {
  let mask = "";
  mask += "0123456789";
  let result = "";
  for (var i = length; i > 0; --i)
    result += mask[Math.round(Math.random() * (mask.length - 1))];
  return result;
};

// get api
router.get("/getAllMediaFiles", (req, res) => {
  query = "SELECT * FROM images";
  db_con.query(query, function (error, results, fields) {
    if (error) {
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      res.send({
        code: 200,
        message: "Success",
        Payload: results,
      });
    }
  });
});

router.post("/deleteImage", (req, res) => {
  const body = req.body;
  image_ids = [];
  req.body.forEach((element) => {
    image_ids.push(element.img_id);
  });
  let allids = image_ids.join(",");
  let query = `DELETE FROM images WHERE img_id IN (` + allids + `);`;
  db_con.query(query, (error, results, fields) => {
    if (error) {
      console.log("error ocurred", error);
      res.send({
        code: 400,
        failed: "error request",
      });
    } else {
      console.log("Resultats: ", results);
      res.send({
        code: 200,
        message: "Deleted Successfully",
      });
    }
  });
});

module.exports = router;
